/* Automatically generated from: virsh.c Makefile.am */
static int
cmdNetworkEdit (vshControl *ctl, const vshCmd *cmd)
{
    int ret = FALSE;
    virNetworkPtr network = NULL;
    char *tmp = NULL;
    char *doc = NULL;
    char *doc_edited = NULL;
    char *doc_reread = NULL;

    if (!vshConnectionUsability(ctl, ctl->conn, TRUE))
        goto cleanup;

    network = vshCommandOptNetwork (ctl, cmd, "network", NULL);
    if (network == NULL)
        goto cleanup;

    /* Get the XML configuration of the network. */
    doc = virNetworkGetXMLDesc (network, 0);
    if (!doc)
        goto cleanup;

    /* Create and open the temporary file. */
    tmp = editWriteToTempFile (ctl, doc);
    if (!tmp) goto cleanup;

    /* Start the editor. */
    if (editFile (ctl, tmp) == -1) goto cleanup;

    /* Read back the edited file. */
    doc_edited = editReadBackFile (ctl, tmp);
    if (!doc_edited) goto cleanup;

    unlink (tmp);
    tmp = NULL;

    /* Compare original XML with edited.  Has it changed at all? */
    if (STREQ (doc, doc_edited)) {
        vshPrint (ctl, _("Network %s XML configuration not changed.\n"),
                  virNetworkGetName (network));
        ret = TRUE;
        goto cleanup;
    }

    /* Now re-read the network XML.  Did someone else change it while
     * it was being edited?  This also catches problems such as us
     * losing a connection or the network going away.
     */
    doc_reread = virNetworkGetXMLDesc (network, 0);
    if (!doc_reread)
        goto cleanup;

    if (STRNEQ (doc, doc_reread)) {
        vshError (ctl, FALSE,
                  "%s", _("ERROR: the XML configuration was changed by another user"));
        goto cleanup;
    }

    /* Everything checks out, so redefine the network. */
    virNetworkFree (network);
    network = virNetworkDefineXML (ctl->conn, doc_edited);
    if (!network)
        goto cleanup;

    vshPrint (ctl, _("Network %s XML configuration edited.\n"),
              virNetworkGetName(network));

    ret = TRUE;

 cleanup:
    if (network)
        virNetworkFree (network);

    free (doc);
    free (doc_edited);
    free (doc_reread);

    if (tmp) {
        unlink (tmp);
        free (tmp);
    }

    return ret;
}
